;SEH macros for masm32
;by hoverlees       2009
;email: 280114160@qq.com

comment ~
Hope these macors will help you.
Use these SEH macros,you can use C++ like syntax to catch and handling the exceptions.The syntax like this:
********************************************************************************
__try exceptionid
	;code snippet which may cause exceptions
__catch exceptionid
	;code snippet will execute when the exception is caught
__finally exceptionid 
;end the exception caught
********************************************************************************
the exceptionid is programmer defined string and a __try-__catch-__finally block must use the same exceptionid.
The macros will use the exceptionid to define global labels,so different __try-__catch__finally block must use different exception ids.
The __try-__catch-__finally block can be nested like this:
********************************************************************************
__try e1
	;your code
__catch e1
	__try e2
		;your code
	__catch e2
		;your code
	__finally e2
__finally e1
********************************************************************************
~

IFNDEF IN_HOVERLEES_SEH
IN_HOVERLEES_SEH	equ	1
IFNDEF SEH
SEH struct
	PrevLink			dd ?
	CurrentHandler	dd ?
	SafeOffset		dd ?
	PrevEsp			dd ?
	PrevEbp			dd ?
SEH ends
ENDIF

__try macro exceptionid
		assume fs:nothing
		push fs:[0]					;7
		mov eax,esp					;
		push fs:[0]					;6
		push ebp					;5
		push eax					;4
		push __finally_&exceptionid		;3
		push __exception_&exceptionid		;2
		push eax					;1
		mov fs:[0],esp
		assume fs:ERROR
endm

__catch macro exceptionid
		add esp,sizeof SEH+4			;- 6 dword
		jmp __finally_&exceptionid
		__exception_&exceptionid:
		push ebp
		mov ebp,esp
		mov edx,[ebp][12]
		assume edx:ptr SEH
		mov eax,[ebp][16]
		assume eax:ptr CONTEXT
		push [edx].SafeOffset
		pop [eax].regEip
		push [edx].PrevEsp
		pop [eax].regEsp
		push [edx].PrevEbp
		pop [eax].regEbp
		assume eax:nothing
endm

__finally macro exceptionid
		mov eax,ExceptionContinueExecution
		pop ebp
		retn 16+sizeof SEH
		__finally_&exceptionid:
		assume fs:nothing
		pop fs:[0]
		assume fs:error
endm

ENDIF